/**
 * @copyright 2015, Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactStylesheet = require('react-stylesheet');

var ButtonRoot = (0, _reactStylesheet.style)('div', {
  displayName: 'ButtonRoot',
  base: {
    borderRadius: 2,
    padding: 4,
    display: 'inline-block',
    textDecoration: 'none',
    cursor: 'pointer',
    textAlign: 'center',
    color: '#666',
    userSelect: 'none',
    WebkitUserSelect: 'none',
    border: '1px solid transparent',

    hover: {
      color: '#262626',
      backgroundColor: '#f5f5f5'
    },

    active: {
      color: '#262626',
      backgroundColor: '#dddddd !important'
    },

    focus: {
      outline: 'none',
      border: '1px solid #B7B7B7'
    }
  },
  active: {
    color: '#262626',
    backgroundColor: '#dddddd !important'
  },
  dimmed: {
    color: '#bbbbbb'
  },
  bold: {
    fontWeight: 'bold'
  }
});

var Button = (function (_React$Component) {
  _inherits(Button, _React$Component);

  function Button() {
    _classCallCheck(this, Button);

    _get(Object.getPrototypeOf(Button.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(Button, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var active = _props.active;
      var bold = _props.bold;
      var _props$size = _props.size;
      var width = _props$size.width;
      var height = _props$size.height;
      var dimmed = _props.dimmed;
      var color = _props.color;
      var backgroundColor = _props.backgroundColor;
      var stylesheet = _props.stylesheet;

      var props = _objectWithoutProperties(_props, ['active', 'bold', 'size', 'dimmed', 'color', 'backgroundColor', 'stylesheet']);

      return _react2['default'].createElement(stylesheet.Root, _extends({}, props, {
        variant: { bold: bold, dimmed: dimmed, active: active },
        style: { width: width, height: height, color: color, backgroundColor: backgroundColor },
        role: 'button'
      }));
    }
  }], [{
    key: 'propTypes',
    value: {
      active: _react.PropTypes.bool,
      bold: _react.PropTypes.bool,
      dimmed: _react.PropTypes.bool,
      size: _react.PropTypes.object,
      color: _react.PropTypes.string,
      backgroundColor: _react.PropTypes.string
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      size: {},
      stylesheet: { Root: ButtonRoot }
    },
    enumerable: true
  }]);

  return Button;
})(_react2['default'].Component);

exports['default'] = Button;
module.exports = exports['default'];
