/**
 * @copyright 2014 Quri, Loïc CHOLLIER
 * @copyright 2015-present, Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _lodashDebounce = require('lodash/debounce');

var _lodashDebounce2 = _interopRequireDefault(_lodashDebounce);

var _lodashNoop = require('lodash/noop');

var _lodashNoop2 = _interopRequireDefault(_lodashNoop);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _tether = require('tether');

var _tether2 = _interopRequireDefault(_tether);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _reactDom = require('react-dom');

var ReactDOM = _interopRequireWildcard(_reactDom);

var _prometheusresearchReactUi = require('@prometheusresearch/react-ui');

var ReactUI = _interopRequireWildcard(_prometheusresearchReactUi);

var _prometheusresearchReactUiStylesheet = require('@prometheusresearch/react-ui/stylesheet');

var _Icon = require('./Icon');

var Icon = _interopRequireWildcard(_Icon);

var _Layer = require('./Layer');

var _Layer2 = _interopRequireDefault(_Layer);

var _datepickerDatePicker = require('./datepicker/DatePicker');

var _datepickerDatePicker2 = _interopRequireDefault(_datepickerDatePicker);

var TETHER_CONFIG = {
  attachment: 'top left',
  targetAttachment: 'bottom left',
  offset: '-5px 0px',
  optimizations: {
    moveElement: false
  },
  constraints: [{
    to: 'window',
    attachment: 'together'
  }]
};

var IconButton = (0, _prometheusresearchReactUiStylesheet.style)(ReactUI.Button, {
  textWidth: 300,

  text: _prometheusresearchReactUiStylesheet.css.rgb(136),
  textHover: _prometheusresearchReactUiStylesheet.css.rgb(68),
  textFocus: _prometheusresearchReactUiStylesheet.css.rgb(0, 126, 229),
  textActive: _prometheusresearchReactUiStylesheet.css.rgb(68),
  textDisabled: _prometheusresearchReactUiStylesheet.css.rgb(200),

  background: _prometheusresearchReactUiStylesheet.css.rgb(255),
  backgroundHover: _prometheusresearchReactUiStylesheet.css.rgb(255),
  backgroundFocus: _prometheusresearchReactUiStylesheet.css.rgb(255),
  backgroundActive: _prometheusresearchReactUiStylesheet.css.rgb(255),
  backgroundDisabled: _prometheusresearchReactUiStylesheet.css.rgb(255),

  border: _prometheusresearchReactUiStylesheet.css.color.transparent,
  borderHover: _prometheusresearchReactUiStylesheet.css.color.transparent,
  borderFocus: _prometheusresearchReactUiStylesheet.css.color.transparent,
  borderActive: _prometheusresearchReactUiStylesheet.css.color.transparent,
  borderDisabled: _prometheusresearchReactUiStylesheet.css.color.transparent,

  shadowFocus: _prometheusresearchReactUiStylesheet.css.none,
  shadowActive: _prometheusresearchReactUiStylesheet.css.none
}, { displayName: 'IconButton' });

var DateField = (function (_React$Component) {
  _inherits(DateField, _React$Component);

  _createClass(DateField, null, [{
    key: 'propTypes',
    value: {
      value: React.PropTypes.string,
      onChange: React.PropTypes.func,
      format: React.PropTypes.string,
      inputProps: React.PropTypes.object,
      inputFormat: React.PropTypes.string,
      defaultText: React.PropTypes.string
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      format: 'x',
      onChange: _lodashNoop2['default']
    },
    enumerable: true
  }]);

  function DateField(props) {
    var _this = this;

    _classCallCheck(this, DateField);

    _get(Object.getPrototypeOf(DateField.prototype), 'constructor', this).call(this, props);

    this.onMode = function (mode) {
      _this.setState({ mode: mode });
    };

    this.onClick = function () {
      ReactDOM.findDOMNode(_this.refs.input).focus();
    };

    this.onLayerDidMount = function (element) {
      var target = ReactDOM.findDOMNode(_this.refs.input);
      _this._tether = new _tether2['default'](_extends({ element: element, target: target }, TETHER_CONFIG));
    };

    this.onLayerDidUpdate = function () {
      if (_this._tetherNeedPosition) {
        _this._tetherNeedPosition = false;
        _this._tether.position();
      }
    };

    this.onLayerWillUnmount = function () {
      _this._tether.disable();
      _this._tether = null;
    };

    this.onChange = function (e) {
      var value = e.target == null ? e : e.target.value; // eslint-disable-line eqeqeq
      var nextState = { inputValue: value };
      var date = (0, _moment2['default'])(value, _this.inputFormat, true);
      if (date.isValid()) {
        nextState = _extends({}, nextState, {
          selectedDate: date.clone(),
          viewDate: date.clone().startOf('month')
        });
      }
      _this.setState(nextState, function () {
        return _this.props.onChange(value === '' ? null : date.format(_this.props.format));
      });
    };

    this.onViewDate = function (viewDate) {
      _this.setState({ viewDate: viewDate });
    };

    this.onSelectedDate = function (date) {
      _this.setState({
        selectedDate: date,
        viewDate: date
      }, _this.onSelectedDateUpdated);
    };

    this.onSelectedDateUpdated = function () {
      var selectedDate = _this.state.selectedDate;

      var inputValue = selectedDate.format(_this.inputFormat);
      var value = selectedDate.format(_this.props.format);
      _this.props.onChange(value);
      _this.setState({ inputValue: inputValue });
      _this.close();
    };

    this.open = function () {
      _this._setOpen(true);
    };

    this.close = function () {
      _this._setOpen(false);
    };

    this._tether = null;
    this._tetherNeedPosition = null;
    this._setOpen = (0, _lodashDebounce2['default'])(function (open) {
      return _this.setState({ open: open });
    }, 0);

    var date = this.props.value ? (0, _moment2['default'])(this.props.value, this.props.format, true) : (0, _moment2['default'])();

    this.state = {
      open: false,
      mode: 'days',
      viewDate: date.clone().startOf('month'),
      selectedDate: date.clone(),
      inputValue: this.props.value ? date.format(this.inputFormat) : this.props.defaultText
    };
  }

  _createClass(DateField, [{
    key: 'render',
    value: function render() {
      var _state = this.state;
      var open = _state.open;
      var mode = _state.mode;

      return React.createElement(
        ReactUI.Block,
        null,
        React.createElement(
          ReactUI.Block,
          { onFocus: this.open, onBlur: this.close },
          React.createElement(ReactUI.Input, _extends({
            style: { paddingLeft: 36 },
            variant: { focus: open },
            ref: 'input',
            type: 'text',
            onChange: this.onChange,
            value: this.state.inputValue
          }, this.props.inputProps)),
          React.createElement(
            ReactUI.Block,
            {
              top: 5,
              left: 5,
              position: 'absolute' },
            React.createElement(IconButton, {
              variant: { focus: open },
              style: { padding: '4px 8px' },
              ref: 'button',
              size: 'small',
              onClick: this.onClick,
              icon: React.createElement(Icon.Calendar, null)
            })
          )
        ),
        open && React.createElement(
          _Layer2['default'],
          {
            didMount: this.onLayerDidMount,
            didUpdate: this.onLayerDidUpdate,
            willUnmount: this.onLayerWillUnmount },
          React.createElement(
            ReactUI.Card,
            null,
            React.createElement(_datepickerDatePicker2['default'], {
              mode: mode,
              onMode: this.onMode,
              onFocus: this.open,
              onBlur: this.close,
              viewDate: this.state.viewDate,
              onViewDate: this.onViewDate,
              value: this.state.selectedDate,
              onChange: this.onSelectedDate
            })
          )
        )
      );
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var nextDate = (0, _moment2['default'])(nextProps.value, nextProps.format, true);
      if (nextDate.isValid()) {
        this.setState({
          viewDate: nextDate.clone().startOf('month'),
          selectedDate: nextDate.clone(),
          inputValue: nextDate.format(this._inputFormatFromProps(nextProps))
        });
      }
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps, nextState) {
      if (nextState.mode !== this.state.mode) {
        this._tetherNeedPosition = true;
      }
    }
  }, {
    key: '_inputFormatFromProps',
    value: function _inputFormatFromProps(props) {
      if (props.inputFormat) {
        return props.inputFormat;
      } else {
        return 'MM/DD/YY';
      }
    }
  }, {
    key: 'inputFormat',
    get: function get() {
      return this._inputFormatFromProps(this.props);
    }
  }]);

  return DateField;
})(React.Component);

exports['default'] = DateField;
module.exports = exports['default'];
