/**
 * @copyright 2014 Quri, Loïc CHOLLIER
 * @copyright 2016 Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _keymirror = require('keymirror');

var _keymirror2 = _interopRequireDefault(_keymirror);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DayView = require('./DayView');

var _DayView2 = _interopRequireDefault(_DayView);

var _MonthView = require('./MonthView');

var _MonthView2 = _interopRequireDefault(_MonthView);

var _YearView = require('./YearView');

var _YearView2 = _interopRequireDefault(_YearView);

var Mode = (0, _keymirror2['default'])({
  days: null,
  months: null,
  years: null
});

var DatePicker = (function (_React$Component) {
  _inherits(DatePicker, _React$Component);

  function DatePicker() {
    var _this = this;

    _classCallCheck(this, DatePicker);

    _get(Object.getPrototypeOf(DatePicker.prototype), 'constructor', this).apply(this, arguments);

    this.showMonths = function () {
      _this.props.onActiveMode(Mode.months);
    };

    this.showYears = function () {
      _this.props.onActiveMode(Mode.years);
    };

    this.showDays = function () {
      _this.props.onActiveMode(Mode.days);
    };
  }

  _createClass(DatePicker, [{
    key: 'render',
    value: function render() {
      var activeMode = this.props.activeMode;

      return _react2['default'].createElement(
        'div',
        { style: this.props.style },
        activeMode === Mode.days && _react2['default'].createElement(_DayView2['default'], {
          selectedDate: this.props.selectedDate,
          onSelectedDate: this.props.onSelectedDate,
          viewDate: this.props.viewDate,
          onViewDate: this.props.onViewDate,
          renderDay: this.props.renderDay,
          style: this.props.pickerStyle,
          tableStyle: this.props.pickerTableStyle,
          showToday: this.props.showToday,
          showMonths: this.showMonths
        }),
        activeMode === Mode.months && _react2['default'].createElement(_MonthView2['default'], {
          selectedDate: this.props.selectedDate,
          onSelectedDate: this.props.onSelectedDate,
          viewDate: this.props.viewDate,
          onViewDate: this.props.onViewDate,
          renderMonth: this.props.renderMonth,
          style: this.props.pickerStyle,
          tableStyle: this.props.pickerTableStyle,
          showYears: this.showYears,
          onClose: this.showDays
        }),
        activeMode === Mode.years && _react2['default'].createElement(_YearView2['default'], {
          selectedDate: this.props.selectedDate,
          onSelectedDate: this.props.onSelectedDate,
          viewDate: this.props.viewDate,
          onViewDate: this.props.onViewDate,
          style: this.props.pickerStyle,
          tableStyle: this.props.pickerTableStyle,
          onClose: this.showMonths
        })
      );
    }
  }], [{
    key: 'Mode',
    value: Mode,
    enumerable: true
  }, {
    key: 'propTypes',
    value: {
      activeMode: _react.PropTypes.oneOf([Mode.days, Mode.months, Mode.years]),
      onActiveMode: _react.PropTypes.func.isRequired,
      viewDate: _react.PropTypes.object.isRequired,
      onViewDate: _react.PropTypes.func.isRequired,
      selectedDate: _react.PropTypes.object.isRequired,
      onSelectedDate: _react.PropTypes.func.isRequired,
      showToday: _react.PropTypes.bool,
      viewMode: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),
      renderDay: _react.PropTypes.func,
      renderMonth: _react.PropTypes.func,
      style: _react.PropTypes.object,
      pickerStyle: _react.PropTypes.object,
      pickerTableStyle: _react.PropTypes.object
    },
    enumerable: true
  }]);

  return DatePicker;
})(_react2['default'].Component);

exports['default'] = DatePicker;
module.exports = exports['default'];
