/**
 * @copyright 2014 Quri, Loïc CHOLLIER
 * @copyright 2015 Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _lodashDebounce = require('lodash/debounce');

var _lodashDebounce2 = _interopRequireDefault(_lodashDebounce);

var _emptyFunction = require('empty/function');

var _emptyFunction2 = _interopRequireDefault(_emptyFunction);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _reactStylesheet = require('react-stylesheet');

var _prometheusresearchReactUiLibInput = require('@prometheusresearch/react-ui/lib/Input');

var _tether = require('tether');

var _tether2 = _interopRequireDefault(_tether);

var _Layer = require('./Layer');

var _Layer2 = _interopRequireDefault(_Layer);

var _DateTimePicker = require('./DateTimePicker');

var _DateTimePicker2 = _interopRequireDefault(_DateTimePicker);

var _DatePicker = require('./DatePicker');

var _DatePicker2 = _interopRequireDefault(_DatePicker);

var _TimePicker = require('./TimePicker');

var _TimePicker2 = _interopRequireDefault(_TimePicker);

var _Icon = require('./Icon');

var Icon = _interopRequireWildcard(_Icon);

var TETHER_CONFIG = {
  attachment: 'top left',
  targetAttachment: 'bottom left',
  optimizations: {
    moveElement: false
  },
  constraints: [{
    to: 'window',
    attachment: 'together'
  }]
};

var DateTimeFieldRoot = 'div';

var DateTimeFieldField = (0, _reactStylesheet.style)('div', {
  base: {
    position: 'relative'
  }
});

var DateTimeFieldInput = (0, _reactStylesheet.style)(_prometheusresearchReactUiLibInput.InputRoot, {
  base: {
    paddingRight: 40
  }
});

var DateTimeFieldButton = (0, _reactStylesheet.style)('span', {
  base: {
    cursor: 'pointer',
    display: 'table-cell',
    position: 'absolute',
    top: 3,
    right: 3,
    padding: '6px 12px',
    fontSize: '12px',
    lineHeight: 1,
    verticalAlign: 'middle',
    color: '#555',
    textAlign: 'center'
  }
});

var DateTimeFieldDropdown = (0, _reactStylesheet.style)('div', {
  base: {
    zIndex: 15000,
    padding: 5,
    backgroundColor: '#fff',
    backgroundClip: 'padding-box',
    border: '1px solid rgba(0,0,0,.15)',
    borderRadius: 2,
    boxShadow: '0 6px 12px rgba(0,0,0,.175)'
  }
});

var DateTimeField = (function (_React$Component) {
  _inherits(DateTimeField, _React$Component);

  _createClass(DateTimeField, null, [{
    key: 'propTypes',
    value: {
      dateTime: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.object]),
      onChange: _react.PropTypes.func,
      format: _react.PropTypes.string,
      inputProps: _react.PropTypes.object,
      inputFormat: _react.PropTypes.string,
      defaultText: _react.PropTypes.string,
      mode: _react.PropTypes.oneOf([_DateTimePicker2['default'].Mode.datetime, _DateTimePicker2['default'].Mode.time, _DateTimePicker2['default'].Mode.date])
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      format: 'x',
      mode: _DateTimePicker2['default'].Mode.datetime,
      onChange: _emptyFunction2['default'],
      stylesheet: {
        Root: DateTimeFieldRoot,
        Field: DateTimeFieldField,
        Input: DateTimeFieldInput,
        Button: DateTimeFieldButton,
        Dropdown: DateTimeFieldDropdown
      }
    },
    enumerable: true
  }]);

  function DateTimeField(props) {
    var _this = this;

    _classCallCheck(this, DateTimeField);

    _get(Object.getPrototypeOf(DateTimeField.prototype), 'constructor', this).call(this, props);

    this._onInputRef = function (input) {
      _this._input = input;
    };

    this._onActiveMode = function (activeMode) {
      _this.setState({ activeMode: activeMode });
    };

    this._onClick = function () {
      _reactDom2['default'].findDOMNode(_this._input).focus();
    };

    this._onLayerDidMount = function (element) {
      var target = _reactDom2['default'].findDOMNode(_this._input);
      _this._tether = new _tether2['default'](_extends({ element: element, target: target }, TETHER_CONFIG));
    };

    this._onLayerDidUpdate = function () {
      if (_this._tetherNeedPosition) {
        _this._tetherNeedPosition = false;
        _this._tether.position();
      }
    };

    this._onLayerWillUnmount = function () {
      _this._tether.disable();
      _this._tether = null;
    };

    this._onChange = function (e) {
      var value = e.target == null ? e : e.target.value; // eslint-disable-line eqeqeq
      var nextState = { inputValue: value };
      var date = (0, _moment2['default'])(value, _this.inputFormat, true);
      if (date.isValid()) {
        nextState = _extends({}, nextState, {
          selectedDate: date.clone(),
          viewDate: date.clone().startOf('month')
        });
      }
      _this.setState(nextState, function () {
        return _this.props.onChange(value === '' ? null : date.format(_this.props.format));
      });
    };

    this._onViewDate = function (viewDate) {
      _this.setState({ viewDate: viewDate });
    };

    this._onSelectedDate = function (date) {
      _this.setState({
        selectedDate: date,
        viewDate: date
      }, _this._onSelectedDateUpdated);
    };

    this._onSelectedDateUpdated = function () {
      var selectedDate = _this.state.selectedDate;

      var inputValue = selectedDate.format(_this.inputFormat);
      var value = selectedDate.format(_this.props.format);
      _this.props.onChange(value);
      _this.setState({ inputValue: inputValue });
      if (_this.props.mode === _DateTimePicker2['default'].Mode.datetime) {
        if (_this.state.activeMode.self === _DateTimePicker2['default'].Mode.date) {
          _this._onActiveMode(_extends({}, _this.state.activeMode, {
            self: _DateTimePicker2['default'].Mode.time
          }));
          _reactDom2['default'].findDOMNode(_this._input).focus();
        }
      } else if (_this.props.mode === _DateTimePicker2['default'].Mode.date) {
        _this._close();
      }
    };

    this._setOpen = function (open) {
      _this.setState({ open: open });
    };

    this._open = function () {
      _this._setOpenDebounced(true);
    };

    this._close = function () {
      _this._setOpenDebounced(false);
    };

    this._input = null;

    this._tether = null;
    this._tetherNeedPosition = null;
    this._setOpenDebounced = (0, _lodashDebounce2['default'])(this._setOpen, 0);

    var date = this.props.dateTime ? (0, _moment2['default'])(this.props.dateTime, this.props.format, true) : (0, _moment2['default'])();

    var self = this.props.mode === _DateTimePicker2['default'].Mode.time ? _DateTimePicker2['default'].Mode.time : _DateTimePicker2['default'].Mode.date;

    this.state = {
      open: false,

      activeMode: {
        self: self,
        date: _DatePicker2['default'].Mode.days,
        time: _TimePicker2['default'].Mode.time
      },

      viewDate: date.clone().startOf('month'),
      selectedDate: date.clone(),

      inputValue: this.props.dateTime ? date.format(this.inputFormat) : ''
    };
  }

  _createClass(DateTimeField, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var mode = _props.mode;
      var stylesheet = _props.stylesheet;
      var defaultText = _props.defaultText;
      var open = this.state.open;
      var Root = stylesheet.Root;
      var Field = stylesheet.Field;
      var Input = stylesheet.Input;
      var Button = stylesheet.Button;
      var Dropdown = stylesheet.Dropdown;

      return _react2['default'].createElement(
        Root,
        null,
        _react2['default'].createElement(
          Field,
          { onFocus: this._open, onBlur: this._close },
          _react2['default'].createElement(Input, _extends({
            placeholder: defaultText,
            ref: this._onInputRef,
            type: 'text',
            onChange: this._onChange,
            value: this.state.inputValue
          }, this.props.inputProps)),
          _react2['default'].createElement(
            Button,
            {
              onClick: this._onClick,
              role: 'button' },
            mode === _DateTimePicker2['default'].Mode.time ? _react2['default'].createElement(Icon.Clock, null) : _react2['default'].createElement(Icon.Calendar, null)
          )
        ),
        open && _react2['default'].createElement(
          _Layer2['default'],
          {
            didMount: this._onLayerDidMount,
            didUpdate: this._onLayerDidUpdate,
            willUnmount: this._onLayerWillUnmount },
          _react2['default'].createElement(
            Dropdown,
            null,
            _react2['default'].createElement(_DateTimePicker2['default'], {
              activeMode: this.state.activeMode,
              onActiveMode: this._onActiveMode,
              onFocus: this._open,
              onBlur: this._close,
              viewDate: this.state.viewDate,
              selectedDate: this.state.selectedDate,
              mode: this.props.mode,
              onViewDate: this._onViewDate,
              onSelectedDate: this._onSelectedDate
            })
          )
        )
      );
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var nextDate = (0, _moment2['default'])(nextProps.dateTime, nextProps.format, true);
      if (nextDate.isValid()) {
        return this.setState({
          viewDate: nextDate.clone().startOf('month'),
          selectedDate: nextDate.clone(),
          inputValue: nextDate.format(this._inputFormatFromProps(nextProps))
        });
      }
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps, nextState) {
      if (nextState.activeMode !== this.state.activeMode) {
        this._tetherNeedPosition = true;
      }
    }
  }, {
    key: '_inputFormatFromProps',
    value: function _inputFormatFromProps(props) {
      if (props.inputFormat) {
        return props.inputFormat;
      } else if (props.mode === _DateTimePicker2['default'].Mode.time) {
        return 'h:mm A';
      } else if (props.mode === _DateTimePicker2['default'].Mode.date) {
        return 'MM/DD/YY';
      } else {
        return 'MM/DD/YY h:mm A';
      }
    }
  }, {
    key: 'inputFormat',
    get: function get() {
      return this._inputFormatFromProps(this.props);
    }
  }]);

  return DateTimeField;
})(_react2['default'].Component);

exports['default'] = DateTimeField;
module.exports = exports['default'];
