/**
 * @copyright 2014 Quri, Loïc CHOLLIER
 * @copyright 2015 Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactStylesheet = require('react-stylesheet');

var _keymirror = require('keymirror');

var _keymirror2 = _interopRequireDefault(_keymirror);

var _DatePicker = require('./DatePicker');

var _DatePicker2 = _interopRequireDefault(_DatePicker);

var _TimePicker = require('./TimePicker');

var _TimePicker2 = _interopRequireDefault(_TimePicker);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _Icon = require('./Icon');

var Icon = _interopRequireWildcard(_Icon);

var Mode = (0, _keymirror2['default'])({
  date: null,
  time: null,
  datetime: null
});

var DateTimePickerRoot = (0, _reactStylesheet.style)('div', {
  displayName: 'DateTimePickerRoot',
  base: {
    focus: {
      outline: 'none'
    }
  }
});

var DateTimePicker = (function (_React$Component) {
  _inherits(DateTimePicker, _React$Component);

  function DateTimePicker() {
    var _this = this;

    _classCallCheck(this, DateTimePicker);

    _get(Object.getPrototypeOf(DateTimePicker.prototype), 'constructor', this).apply(this, arguments);

    this._onActiveMode = function () {
      var activeMode = _this.props.activeMode;

      var self = activeMode.self === Mode.date ? Mode.time : Mode.date;
      _this.props.onActiveMode(_extends({}, activeMode, { self: self }));
    };

    this._onActiveDateMode = function (date) {
      var activeMode = _this.props.activeMode;

      _this.props.onActiveMode(_extends({}, activeMode, { date: date }));
    };

    this._onActiveTimeMode = function (time) {
      var activeMode = _this.props.activeMode;

      _this.props.onActiveMode(_extends({}, activeMode, { time: time }));
    };
  }

  _createClass(DateTimePicker, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var activeMode = _props.activeMode;
      var mode = _props.mode;
      var viewDate = _props.viewDate;
      var onViewDate = _props.onViewDate;
      var selectedDate = _props.selectedDate;
      var onSelectedDate = _props.onSelectedDate;
      var stylesheet = _props.stylesheet;
      var Root = stylesheet.Root;
      var DatePicker = stylesheet.DatePicker;
      var TimePicker = stylesheet.TimePicker;

      return _react2['default'].createElement(
        Root,
        {
          tabIndex: 0,
          onFocus: this.props.onFocus,
          onBlur: this.props.onBlur },
        activeMode.self === Mode.date && _react2['default'].createElement(DatePicker, {
          activeMode: activeMode.date,
          onActiveMode: this._onActiveDateMode,
          viewDate: viewDate,
          onViewDate: onViewDate,
          selectedDate: selectedDate,
          onSelectedDate: onSelectedDate
        }),
        mode === Mode.datetime && _react2['default'].createElement(
          _Button2['default'],
          {
            size: { width: '100%' },
            onClick: this._onActiveMode },
          mode === DateTimePicker.Mode.time ? _react2['default'].createElement(Icon.Clock, null) : _react2['default'].createElement(Icon.Calendar, null)
        ),
        activeMode.self === Mode.time && _react2['default'].createElement(TimePicker, {
          activeMode: activeMode.time,
          onActiveMode: this._onActiveTimeMode,
          viewDate: viewDate,
          onViewDate: onViewDate,
          selectedDate: selectedDate,
          onSelectedDate: onSelectedDate
        })
      );
    }
  }], [{
    key: 'Mode',
    value: Mode,
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      stylesheet: {
        Root: DateTimePickerRoot,
        DatePicker: _DatePicker2['default'],
        TimePicker: _TimePicker2['default']
      }
    },
    enumerable: true
  }, {
    key: 'propTypes',
    value: {
      activeMode: _react.PropTypes.object.isRequired,
      onActiveMode: _react.PropTypes.func.isRequired,

      viewDate: _react.PropTypes.object.isRequired,
      onViewDate: _react.PropTypes.func.isRequired,

      selectedDate: _react.PropTypes.object.isRequired,
      onSelectedDate: _react.PropTypes.func.isRequired,

      onFocus: _react.PropTypes.func,
      onBlur: _react.PropTypes.func,

      mode: _react.PropTypes.oneOf([Mode.date, Mode.time, Mode.datetime])
    },
    enumerable: true
  }]);

  return DateTimePicker;
})(_react2['default'].Component);

exports['default'] = DateTimePicker;
module.exports = exports['default'];
