/**
 * @copyright 2014 Quri, Loïc CHOLLIER
 * @copyright 2015 Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactStylesheet = require('react-stylesheet');

var _Day = require('./Day');

var _Day2 = _interopRequireDefault(_Day);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

function renderDay(props) {
  return _react2['default'].createElement(_Day2['default'], props);
}

var DayViewRoot = (0, _reactStylesheet.style)('div', {
  displayName: 'DayViewRoot',
  base: {
    display: 'block'
  }
});

var DayViewDayWrapper = (0, _reactStylesheet.style)('td', {
  displayName: 'DayViewDayWrapper',
  base: {
    textAlign: 'center'
  }
});

var DayViewDayOfWeek = (0, _reactStylesheet.style)('th', {
  displayName: 'DayViewDayOfWeek',
  base: {
    textAlign: 'center',
    padding: 5
  }
});

var DayView = (function (_React$Component) {
  _inherits(DayView, _React$Component);

  function DayView() {
    var _this = this;

    _classCallCheck(this, DayView);

    _get(Object.getPrototypeOf(DayView.prototype), 'constructor', this).apply(this, arguments);

    this.onNextMonth = function () {
      var viewDate = _this.props.viewDate.clone().add(1, 'months');
      _this.props.onViewDate(viewDate);
    };

    this.onPrevMonth = function () {
      _this.props.onViewDate(_this.props.viewDate.clone().subtract(1, 'months'));
    };
  }

  _createClass(DayView, [{
    key: 'render',
    value: function render() {
      var _props$stylesheet = this.props.stylesheet;
      var Root = _props$stylesheet.Root;
      var DayOfWeek = _props$stylesheet.DayOfWeek;

      return _react2['default'].createElement(
        Root,
        { style: this.props.style },
        _react2['default'].createElement(
          'table',
          { style: this.props.tableStyle },
          _react2['default'].createElement(
            'thead',
            null,
            _react2['default'].createElement(
              'tr',
              null,
              _react2['default'].createElement(
                'th',
                null,
                _react2['default'].createElement(
                  _Button2['default'],
                  { bold: true, onClick: this.onPrevMonth, size: { width: '100%', height: 32 } },
                  '‹'
                )
              ),
              _react2['default'].createElement(
                'th',
                { colSpan: '5' },
                _react2['default'].createElement(
                  _Button2['default'],
                  { bold: true, size: { width: '100%' }, onClick: this.props.showMonths },
                  _moment2['default'].months()[this.props.viewDate.month()],
                  ' ',
                  this.props.viewDate.year()
                )
              ),
              _react2['default'].createElement(
                'th',
                null,
                _react2['default'].createElement(
                  _Button2['default'],
                  { bold: true, onClick: this.onNextMonth, size: { width: '100%', height: 32 } },
                  '›'
                )
              )
            ),
            _react2['default'].createElement(
              'tr',
              null,
              _react2['default'].createElement(
                DayOfWeek,
                null,
                'Su'
              ),
              _react2['default'].createElement(
                DayOfWeek,
                null,
                'Mo'
              ),
              _react2['default'].createElement(
                DayOfWeek,
                null,
                'Tu'
              ),
              _react2['default'].createElement(
                DayOfWeek,
                null,
                'We'
              ),
              _react2['default'].createElement(
                DayOfWeek,
                null,
                'Th'
              ),
              _react2['default'].createElement(
                DayOfWeek,
                null,
                'Fr'
              ),
              _react2['default'].createElement(
                DayOfWeek,
                null,
                'Sa'
              )
            )
          ),
          _react2['default'].createElement(
            'tbody',
            null,
            this.renderDays()
          )
        )
      );
    }
  }, {
    key: 'renderDays',
    value: function renderDays() {
      var DayWrapper = this.props.stylesheet.DayWrapper;
      var _props = this.props;
      var viewDate = _props.viewDate;
      var selectedDate = _props.selectedDate;
      var showToday = _props.showToday;

      var today = (0, _moment2['default'])();
      var date = startDateFor(viewDate);
      var endDate = endDateFor(viewDate);

      var rows = [];
      var cells = [];

      while (date.isBefore(endDate)) {
        var isActive = date.isSame(selectedDate, 'day');
        var isToday = date.isSame(today, 'day');
        cells.push(_react2['default'].createElement(
          DayWrapper,
          { key: date.month() + '-' + date.date() },
          this.props.renderDay({
            onClick: this.props.onSelectedDate,
            outOfRange: date.isBefore(viewDate, 'month') || date.isAfter(viewDate, 'month'),
            value: date,
            date: date,
            active: isActive,
            today: isToday,
            showToday: showToday
          })
        ));

        if (date.weekday() === today.clone().endOf('week').weekday()) {
          rows.push(_react2['default'].createElement(
            'tr',
            { key: date.month() + '-' + date.date() },
            cells
          ));
          cells = [];
        }

        date = date.clone().add(1, 'days');
      }

      return rows;
    }
  }], [{
    key: 'propTypes',
    value: {
      viewDate: _react.PropTypes.object.isRequired,
      onViewDate: _react.PropTypes.func.isRequired,
      selectedDate: _react.PropTypes.object.isRequired,
      onSelectedDate: _react.PropTypes.func.isRequired,
      showToday: _react.PropTypes.bool,
      showMonths: _react.PropTypes.func.isRequired,
      renderDay: _react.PropTypes.func,
      style: _react.PropTypes.object,
      tableStyle: _react.PropTypes.object
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      showToday: true,
      renderDay: renderDay,
      stylesheet: {
        Root: DayViewRoot,
        DayWrapper: DayViewDayWrapper,
        DayOfWeek: DayViewDayOfWeek
      }
    },
    enumerable: true
  }]);

  return DayView;
})(_react2['default'].Component);

exports['default'] = DayView;

function startDateFor(date) {
  var startDate = date.clone();
  startDate = startDate.subtract(1, 'months');
  startDate = startDate.date(startDate.daysInMonth());
  startDate = startDate.startOf('week');
  return startDate;
}

function endDateFor(date) {
  var startDate = startDateFor(date);
  var endDate = startDate.clone().add(42, 'days');
  return endDate;
}
module.exports = exports['default'];
