/**
 * @copyright 2014 Quri, Loïc CHOLLIER
 * @copyright 2015 Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _keymirror = require('keymirror');

var _keymirror2 = _interopRequireDefault(_keymirror);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _MinuteView = require('./MinuteView');

var _MinuteView2 = _interopRequireDefault(_MinuteView);

var _HourView = require('./HourView');

var _HourView2 = _interopRequireDefault(_HourView);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _Icon = require('./Icon');

var Icon = _interopRequireWildcard(_Icon);

var Mode = (0, _keymirror2['default'])({
  time: null,
  minutes: null,
  hours: null
});

var TimePicker = (function (_React$Component) {
  _inherits(TimePicker, _React$Component);

  function TimePicker() {
    var _this = this;

    _classCallCheck(this, TimePicker);

    _get(Object.getPrototypeOf(TimePicker.prototype), 'constructor', this).apply(this, arguments);

    this.onPrevHour = function () {
      var selectedDate = _this.props.selectedDate.subtract(1, 'hours');
      _this.props.onSelectedDate(selectedDate);
    };

    this.onNextHour = function () {
      var selectedDate = _this.props.selectedDate.add(1, 'hours');
      _this.props.onSelectedDate(selectedDate);
    };

    this.onPrevMinute = function () {
      var selectedDate = _this.props.selectedDate.subtract(1, 'minutes');
      _this.props.onSelectedDate(selectedDate);
    };

    this.onNextMinute = function () {
      var selectedDate = _this.props.selectedDate.add(1, 'minutes');
      _this.props.onSelectedDate(selectedDate);
    };

    this._setTimeMode = function () {
      _this.props.onActiveMode(Mode.time);
    };

    this._setMinutesMode = function () {
      _this.props.onActiveMode(Mode.minutes);
    };

    this._setHoursMode = function () {
      _this.props.onActiveMode(Mode.hours);
    };
  }

  _createClass(TimePicker, [{
    key: 'render',
    value: function render() {
      var activeMode = this.props.activeMode;

      return _react2['default'].createElement(
        'div',
        null,
        activeMode === Mode.time && _react2['default'].createElement(
          'div',
          null,
          _react2['default'].createElement(
            'table',
            null,
            _react2['default'].createElement(
              'tbody',
              null,
              _react2['default'].createElement(
                'tr',
                null,
                _react2['default'].createElement(
                  'td',
                  null,
                  _react2['default'].createElement(
                    _Button2['default'],
                    { onClick: this.onNextHour },
                    _react2['default'].createElement(Icon.ChevronUp, null)
                  )
                ),
                _react2['default'].createElement('td', null),
                _react2['default'].createElement(
                  'td',
                  null,
                  _react2['default'].createElement(
                    _Button2['default'],
                    { onClick: this.onNextMinute },
                    _react2['default'].createElement(Icon.ChevronUp, null)
                  )
                )
              ),
              _react2['default'].createElement(
                'tr',
                null,
                _react2['default'].createElement(
                  'td',
                  null,
                  _react2['default'].createElement(
                    _Button2['default'],
                    { onClick: this._setHoursMode },
                    this.props.selectedDate.format('HH')
                  )
                ),
                _react2['default'].createElement('td', null),
                _react2['default'].createElement(
                  'td',
                  null,
                  _react2['default'].createElement(
                    _Button2['default'],
                    { onClick: this._setMinutesMode },
                    this.props.selectedDate.format('mm')
                  )
                )
              ),
              _react2['default'].createElement(
                'tr',
                null,
                _react2['default'].createElement(
                  'td',
                  null,
                  _react2['default'].createElement(
                    _Button2['default'],
                    { onClick: this.onPrevHour },
                    _react2['default'].createElement(Icon.ChevronDown, null)
                  )
                ),
                _react2['default'].createElement('td', null),
                _react2['default'].createElement(
                  'td',
                  null,
                  _react2['default'].createElement(
                    _Button2['default'],
                    { onClick: this.onPrevMinute },
                    _react2['default'].createElement(Icon.ChevronDown, null)
                  )
                )
              )
            )
          )
        ),
        activeMode === Mode.hours && _react2['default'].createElement(_HourView2['default'], {
          onSelectedDate: this.props.onSelectedDate,
          selectedDate: this.props.selectedDate,
          onClose: this._setTimeMode
        }),
        activeMode === Mode.minutes && _react2['default'].createElement(_MinuteView2['default'], {
          onSelectedDate: this.props.onSelectedDate,
          selectedDate: this.props.selectedDate,
          onClose: this._setTimeMode
        })
      );
    }
  }], [{
    key: 'Mode',
    value: Mode,
    enumerable: true
  }, {
    key: 'propTypes',
    value: {
      activeMode: _react.PropTypes.oneOf([Mode.time, Mode.minutes, Mode.hours]).isRequired,
      onActiveMode: _react.PropTypes.func.isRequired,
      viewDate: _react.PropTypes.object.isRequired,
      onViewDate: _react.PropTypes.func.isRequired,
      selectedDate: _react.PropTypes.object.isRequired,
      onSelectedDate: _react.PropTypes.func.isRequired
    },
    enumerable: true
  }]);

  return TimePicker;
})(_react2['default'].Component);

exports['default'] = TimePicker;
module.exports = exports['default'];
