/**
 * @copyright 2014 Quri, Loïc CHOLLIER
 * @copyright 2015-present Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _lodashNoop = require('lodash/noop');

var _lodashNoop2 = _interopRequireDefault(_lodashNoop);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _prometheusresearchReactUi = require('@prometheusresearch/react-ui');

var ReactUI = _interopRequireWildcard(_prometheusresearchReactUi);

var _DayView = require('./DayView');

var _DayView2 = _interopRequireDefault(_DayView);

var _MonthView = require('./MonthView');

var _MonthView2 = _interopRequireDefault(_MonthView);

var _YearView = require('./YearView');

var _YearView2 = _interopRequireDefault(_YearView);

var DatePicker = (function (_React$Component) {
  _inherits(DatePicker, _React$Component);

  function DatePicker() {
    var _this = this;

    _classCallCheck(this, DatePicker);

    _get(Object.getPrototypeOf(DatePicker.prototype), 'constructor', this).apply(this, arguments);

    this.onMonthSelect = function (viewDate) {
      _this.props.onViewDate(viewDate);
      _this.props.onMode('days');
    };

    this.onYearSelect = function (viewDate) {
      _this.props.onViewDate(viewDate);
      _this.props.onMode('months');
    };

    this.showMonths = function () {
      _this.props.onMode('months');
    };

    this.showYears = function () {
      _this.props.onMode('years');
    };

    this.showDays = function () {
      _this.props.onMode('days');
    };
  }

  _createClass(DatePicker, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var style = _props.style;
      var onFocus = _props.onFocus;
      var onBlur = _props.onBlur;
      var mode = _props.mode;
      var onMode = _props.onMode;
      var value = _props.value;
      var onChange = _props.onChange;
      var viewDate = _props.viewDate;
      var onViewDate = _props.onViewDate;
      var renderDay = _props.renderDay;
      var Month = _props.Month;

      return React.createElement(
        ReactUI.Block,
        {
          style: style,
          onFocus: onFocus,
          onBlur: onBlur },
        mode === 'days' && React.createElement(_DayView2['default'], {
          value: value,
          onChange: onChange,
          viewDate: viewDate,
          onViewDate: onViewDate,
          renderDay: renderDay,
          showMonths: this.showMonths
        }),
        mode === 'months' && React.createElement(_MonthView2['default'], {
          Month: Month,
          value: value,
          onChange: onChange,
          viewDate: viewDate,
          onViewDate: onViewDate,
          onViewDateSelect: this.onMonthSelect,
          onMode: onMode
        }),
        mode === 'years' && React.createElement(_YearView2['default'], {
          value: value,
          onChange: onChange,
          viewDate: viewDate,
          onViewDate: onViewDate,
          onViewDateSelect: this.onYearSelect
        })
      );
    }
  }], [{
    key: 'propTypes',
    value: {
      mode: React.PropTypes.oneOf(['days', 'months', 'years']).isRequired,
      onMode: React.PropTypes.func.isRequired,
      value: React.PropTypes.object.isRequired,
      onChange: React.PropTypes.func.isRequired,

      viewDate: React.PropTypes.object.isRequired,
      onViewDate: React.PropTypes.func.isRequired,

      renderDay: React.PropTypes.func,
      Month: React.PropTypes.func,
      style: React.PropTypes.object
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      mode: 'days',
      onClose: _lodashNoop2['default']
    },
    enumerable: true
  }]);

  return DatePicker;
})(React.Component);

exports['default'] = DatePicker;
module.exports = exports['default'];
