/**
 * @copyright 2014 Quri, Loïc CHOLLIER
 * @copyright 2015-present Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _prometheusresearchReactUi = require('@prometheusresearch/react-ui');

var ReactUI = _interopRequireWildcard(_prometheusresearchReactUi);

var _prometheusresearchReactUiStylesheet = require('@prometheusresearch/react-ui/stylesheet');

var _Paginator = require('../Paginator');

var _Paginator2 = _interopRequireDefault(_Paginator);

var _Day = require('./Day');

var _Day2 = _interopRequireDefault(_Day);

var DayView = (function (_React$Component) {
  _inherits(DayView, _React$Component);

  function DayView() {
    var _this = this;

    _classCallCheck(this, DayView);

    _get(Object.getPrototypeOf(DayView.prototype), 'constructor', this).apply(this, arguments);

    this.onNextMonth = function () {
      var viewDate = _this.props.viewDate.clone().add(1, 'months');
      _this.props.onViewDate(viewDate);
    };

    this.onPrevMonth = function () {
      _this.props.onViewDate(_this.props.viewDate.clone().subtract(1, 'months'));
    };
  }

  _createClass(DayView, [{
    key: 'render',
    value: function render() {
      return _react2['default'].createElement(
        _Paginator2['default'],
        {
          title: _react2['default'].createElement(
            'span',
            null,
            _moment2['default'].months()[this.props.viewDate.month()],
            ' ',
            this.props.viewDate.year()
          ),
          onPrev: this.onPrevMonth,
          onNext: this.onNextMonth,
          onUp: this.props.showMonths },
        this.renderDays()
      );
    }
  }, {
    key: 'renderDays',
    value: function renderDays() {
      var _props = this.props;
      var viewDate = _props.viewDate;
      var value = _props.value;
      var showToday = _props.showToday;
      var Day = _props.Day;

      var today = (0, _moment2['default'])();
      var date = startDateFor(viewDate);
      var endDate = endDateFor(viewDate);

      var rows = [];
      var cells = [];

      while (date.isBefore(endDate)) {
        var isActive = date.isSame(value, 'day');
        var isToday = date.isSame(today, 'day');
        cells.push(_react2['default'].createElement(Day, {
          key: date.month() + '-' + date.date(),
          onClick: this.props.onChange,
          outOfRange: date.isBefore(viewDate, 'month') || date.isAfter(viewDate, 'month'),
          value: date,
          date: date,
          active: isActive,
          today: isToday,
          showToday: true
        }));

        if (date.weekday() === today.clone().endOf('week').weekday()) {
          rows.push(_react2['default'].createElement(
            ReactUI.Block,
            { key: date.month() + '-' + date.date() },
            cells
          ));
          cells = [];
        }

        date = date.clone().add(1, 'days');
      }

      return rows;
    }
  }], [{
    key: 'propTypes',
    value: {
      viewDate: _react2['default'].PropTypes.object.isRequired,
      onViewDate: _react2['default'].PropTypes.func.isRequired,
      value: _react2['default'].PropTypes.object.isRequired,
      onChange: _react2['default'].PropTypes.func.isRequired,
      showToday: _react2['default'].PropTypes.bool,
      showMonths: _react2['default'].PropTypes.func.isRequired,
      style: _react2['default'].PropTypes.object,
      tableStyle: _react2['default'].PropTypes.object,
      Day: _react2['default'].PropTypes.func
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      showToday: true,
      Day: _Day2['default']
    },
    enumerable: true
  }, {
    key: 'stylesheet',
    value: (0, _prometheusresearchReactUiStylesheet.create)({

      DayOfWeek: {
        Component: 'th',
        textAlign: 'center',
        height: 30,
        width: 30,
        padding: 5,
        fontSize: '90%',
        color: _prometheusresearchReactUiStylesheet.css.rgb(136),
        fontWeight: 'normal'
      }
    }),
    enumerable: true
  }]);

  return DayView;
})(_react2['default'].Component);

exports['default'] = DayView;

function startDateFor(date) {
  var startDate = date.clone();
  startDate = startDate.subtract(1, 'months');
  startDate = startDate.date(startDate.daysInMonth());
  startDate = startDate.startOf('week');
  return startDate;
}

function endDateFor(date) {
  var startDate = startDateFor(date);
  var endDate = startDate.clone().add(42, 'days');
  return endDate;
}
module.exports = exports['default'];
