/**
 * @copyright 2014 Quri, Loïc CHOLLIER
 * @copyright 2015-present Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _lodashChunk = require('lodash/chunk');

var _lodashChunk2 = _interopRequireDefault(_lodashChunk);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Paginator = require('../Paginator');

var _Paginator2 = _interopRequireDefault(_Paginator);

var _Month = require('./Month');

var _Month2 = _interopRequireDefault(_Month);

var MONTHS_SHORT = _moment2['default'].monthsShort();
var YEAR_MONTH_RANGE = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11];

var MonthView = (function (_React$Component) {
  _inherits(MonthView, _React$Component);

  function MonthView() {
    var _this = this;

    _classCallCheck(this, MonthView);

    _get(Object.getPrototypeOf(MonthView.prototype), 'constructor', this).apply(this, arguments);

    this.onYearsMode = function () {
      _this.props.onMode('years');
    };

    this.onNextYear = function () {
      var viewDate = _this.props.viewDate.clone().add(1, 'years');
      _this.props.onViewDate(viewDate);
    };

    this.onPrevYear = function () {
      var viewDate = _this.props.viewDate.clone().subtract(1, 'years');
      _this.props.onViewDate(viewDate);
    };

    this.onMonthClick = function (month) {
      var viewDate = _this.props.viewDate.clone().month(month);
      _this.props.onViewDateSelect(viewDate);
    };
  }

  _createClass(MonthView, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props;
      var Month = _props.Month;
      var viewDate = _props.viewDate;
      var _props$value = _props.value;
      var value = _props$value === undefined ? (0, _moment2['default'])() : _props$value;

      var viewYear = viewDate.year();
      var year = value.year();
      var month = value.month();
      var cells = YEAR_MONTH_RANGE.map(function (m) {
        return _react2['default'].createElement(Month, {
          key: m,
          active: m === month && viewYear === year,
          month: m,
          year: viewYear,
          value: MONTHS_SHORT[m],
          onClick: _this2.onMonthClick
        });
      });
      var rows = (0, _lodashChunk2['default'])(cells, 3).map(function (row, idx) {
        return _react2['default'].createElement(
          'div',
          { key: idx },
          row
        );
      });
      return _react2['default'].createElement(
        _Paginator2['default'],
        {
          title: this.props.viewDate.year(),
          onPrev: this.onPrevYear,
          onNext: this.onNextYear,
          onUp: this.onYearsMode },
        rows
      );
    }
  }], [{
    key: 'propTypes',
    value: {
      value: _react2['default'].PropTypes.object,
      showYears: _react2['default'].PropTypes.func.isRequired,
      viewDate: _react2['default'].PropTypes.object.isRequired,
      onViewDate: _react2['default'].PropTypes.func.isRequired,
      onViewDateSelect: _react2['default'].PropTypes.func.isRequired,
      Month: _react2['default'].PropTypes.func
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      Month: _Month2['default']
    },
    enumerable: true
  }]);

  return MonthView;
})(_react2['default'].Component);

exports['default'] = MonthView;
module.exports = exports['default'];
