/**
 * @copyright 2014 Quri, Loïc CHOLLIER
 * @copyright 2015-present Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodashChunk = require('lodash/chunk');

var _lodashChunk2 = _interopRequireDefault(_lodashChunk);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _Paginator = require('../Paginator');

var _Paginator2 = _interopRequireDefault(_Paginator);

var _Year = require('./Year');

var _Year2 = _interopRequireDefault(_Year);

var YearView = (function (_React$Component) {
  _inherits(YearView, _React$Component);

  function YearView() {
    var _this = this;

    _classCallCheck(this, YearView);

    _get(Object.getPrototypeOf(YearView.prototype), 'constructor', this).apply(this, arguments);

    this.onPrevDecade = function () {
      _this.props.onViewDate(_this.props.viewDate.clone().subtract(10, 'years'));
    };

    this.onNextDecade = function () {
      _this.props.onViewDate(_this.props.viewDate.clone().add(10, 'years'));
    };

    this.onYearClick = function (year) {
      _this.props.onViewDateSelect(_this.props.viewDate.clone().year(year));
    };
  }

  /**
   * Produce a year range for the provided `date`.
   */

  _createClass(YearView, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props;
      var Year = _props.Year;
      var viewDate = _props.viewDate;
      var _props$value = _props.value;
      var value = _props$value === undefined ? (0, _moment2['default'])() : _props$value;

      var viewYear = parseInt(viewDate.year() / 10, 10) * 10;
      var year = value.year();
      var cells = decadeYearRange(viewDate).map(function (item) {
        return _react2['default'].createElement(Year, {
          key: item.year,
          year: item.year,
          active: item.year === year,
          outOfRange: item.outOfRange,
          onClick: _this2.onYearClick
        });
      });
      var rows = (0, _lodashChunk2['default'])(cells, 3).map(function (row, idx) {
        return _react2['default'].createElement(
          'div',
          { key: idx },
          row
        );
      });
      return _react2['default'].createElement(
        _Paginator2['default'],
        {
          onPrev: this.onPrevDecade,
          onNext: this.onNextDecade,
          title: viewYear + ' — ' + (viewYear + 9) },
        rows
      );
    }
  }], [{
    key: 'propTypes',
    value: {
      viewDate: _react2['default'].PropTypes.object.isRequired,
      value: _react2['default'].PropTypes.object.isRequired,
      onViewDate: _react2['default'].PropTypes.func.isRequired,
      onViewDateSelect: _react2['default'].PropTypes.func.isRequired,
      onClose: _react2['default'].PropTypes.func.isRequired
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      Year: _Year2['default']
    },
    enumerable: true
  }]);

  return YearView;
})(_react2['default'].Component);

exports['default'] = YearView;
function decadeYearRange(date) {
  var start = Math.floor(date.year() / 10) * 10;
  var end = start + 10;
  var range = [];
  for (var year = start - 1; year <= end; year++) {
    var outOfRange = year === start - 1 || year === end;
    range.push({ year: year, outOfRange: outOfRange });
  }
  return range;
}
module.exports = exports['default'];
