/**
 * @copyright 2014 Quri, Loïc CHOLLIER
 * @copyright 2015-present Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _prometheusresearchReactUi = require('@prometheusresearch/react-ui');

var ReactUI = _interopRequireWildcard(_prometheusresearchReactUi);

var _prometheusresearchReactUiStylesheet = require('@prometheusresearch/react-ui/stylesheet');

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var Mode = {
  time: 'time',
  minutes: 'minutes',
  hours: 'hours'
};

var HOUR_RANGE = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11];

var HourButton = (function (_React$Component) {
  _inherits(HourButton, _React$Component);

  function HourButton() {
    var _this = this;

    _classCallCheck(this, HourButton);

    _get(Object.getPrototypeOf(HourButton.prototype), 'constructor', this).apply(this, arguments);

    this.state = { hover: false };

    this.onMouseEnter = function () {
      return _this.setState({ hover: true });
    };

    this.onMouseLeave = function () {
      return _this.setState({ hover: false });
    };

    this.onClick = function () {
      return _this.props.onSelectedDate(_this.props.date);
    };
  }

  _createClass(HourButton, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var date = _props.date;
      var selectedDate = _props.selectedDate;
      var onSelectedDate = _props.onSelectedDate;
      var hover = this.state.hover;

      var selected = selectedDate.hour() === date.hour();
      return React.createElement(
        ReactUI.Block,
        {
          style: { borderBottom: hover ? _prometheusresearchReactUiStylesheet.css.border(1, _prometheusresearchReactUiStylesheet.css.rgb(180)) : _prometheusresearchReactUiStylesheet.css.border(1, _prometheusresearchReactUiStylesheet.css.color.transparent) },
          onMouseEnter: this.onMouseEnter,
          onMouseLeave: this.onMouseLeave },
        React.createElement(
          _Button2['default'],
          { cellSize: 24, width: 1, emphasis: selected, onClick: this.onClick },
          date.format('HH')
        ),
        React.createElement(MinuteButton, {
          hover: hover,
          selectedDate: selectedDate,
          renderSelected: function (minutes) {
            return minutes < 30;
          },
          date: date,
          onSelectedDate: onSelectedDate
        }),
        React.createElement(MinuteButton, {
          hover: hover,
          selectedDate: selectedDate,
          renderSelected: function (minutes) {
            return minutes >= 30;
          },
          date: date.clone().add(30, 'minutes'),
          onSelectedDate: onSelectedDate
        })
      );
    }
  }]);

  return HourButton;
})(React.Component);

var MinuteButton = (function (_React$Component2) {
  _inherits(MinuteButton, _React$Component2);

  function MinuteButton() {
    var _this2 = this;

    _classCallCheck(this, MinuteButton);

    _get(Object.getPrototypeOf(MinuteButton.prototype), 'constructor', this).apply(this, arguments);

    this.onClick = function () {
      return _this2.props.onSelectedDate(_this2.props.date);
    };
  }

  _createClass(MinuteButton, [{
    key: 'render',
    value: function render() {
      var _props2 = this.props;
      var date = _props2.date;
      var hover = _props2.hover;
      var selectedDate = _props2.selectedDate;
      var renderSelected = _props2.renderSelected;

      var selected = selectedDate.hour() === date.hour() && selectedDate.minutes() === date.minutes();
      if (renderSelected && !hover && renderSelected(selectedDate.minutes()) && selectedDate.hour() === date.hour()) {
        selected = true;
        date = selectedDate;
      }
      var children = hover || selected ? ' : ' + date.format('mm') : null;
      return React.createElement(
        _Button2['default'],
        {
          onClick: this.onClick,
          width: 1.1,
          cellSize: 24,
          emphasis: selected },
        children
      );
    }
  }]);

  return MinuteButton;
})(React.Component);

var TimePicker = (function (_React$Component3) {
  _inherits(TimePicker, _React$Component3);

  function TimePicker() {
    _classCallCheck(this, TimePicker);

    _get(Object.getPrototypeOf(TimePicker.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(TimePicker, [{
    key: 'render',
    value: function render() {
      var _props3 = this.props;
      var viewDate = _props3.viewDate;
      var selectedDate = _props3.selectedDate;
      var onSelectedDate = _props3.onSelectedDate;

      var startDate = startOfDay(viewDate);
      var dayRange = HOUR_RANGE.map(function (d) {
        return startDate.clone().add(d, 'hours');
      });
      var nightRange = HOUR_RANGE.map(function (d) {
        return startDate.clone().add(d + 12, 'hours');
      });
      return React.createElement(
        ReactUI.Block,
        { style: { borderTop: _prometheusresearchReactUiStylesheet.css.border(1, _prometheusresearchReactUiStylesheet.css.rgb(180)) } },
        React.createElement(
          ReactUI.Block,
          { inline: true, style: { borderRight: _prometheusresearchReactUiStylesheet.css.border(1, _prometheusresearchReactUiStylesheet.css.rgb(180)) } },
          dayRange.map(function (date) {
            return React.createElement(
              ReactUI.Block,
              null,
              React.createElement(HourButton, {
                key: date.hour(),
                date: date,
                selectedDate: selectedDate,
                onSelectedDate: onSelectedDate
              })
            );
          })
        ),
        React.createElement(
          ReactUI.Block,
          { inline: true },
          nightRange.map(function (date) {
            return React.createElement(
              ReactUI.Block,
              null,
              React.createElement(HourButton, {
                key: date.hour(),
                date: date,
                selectedDate: selectedDate,
                onSelectedDate: onSelectedDate
              })
            );
          })
        )
      );
    }
  }], [{
    key: 'Mode',
    value: Mode,
    enumerable: true
  }, {
    key: 'propTypes',
    value: {
      onActiveMode: React.PropTypes.func.isRequired,
      viewDate: React.PropTypes.object.isRequired,
      onViewDate: React.PropTypes.func.isRequired,
      selectedDate: React.PropTypes.object.isRequired,
      onSelectedDate: React.PropTypes.func.isRequired
    },
    enumerable: true
  }]);

  return TimePicker;
})(React.Component);

exports['default'] = TimePicker;

function startOfDay(date) {
  return date.clone().hours(0).minutes(0).seconds(0);
}
module.exports = exports['default'];
