/**
 * @copyright 2015-present, Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports['default'] = Button;

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _prometheusresearchReactUi = require('@prometheusresearch/react-ui');

var ReactUI = _interopRequireWildcard(_prometheusresearchReactUi);

var _prometheusresearchReactUiStylesheet = require('@prometheusresearch/react-ui/stylesheet');

var _theme = require('./theme');

var ButtonBase = (0, _prometheusresearchReactUiStylesheet.style)(ReactUI.Button, {
  textWidth: 300,

  text: _prometheusresearchReactUiStylesheet.css.rgb(70),
  textHover: _prometheusresearchReactUiStylesheet.css.rgb(68),
  textFocus: _prometheusresearchReactUiStylesheet.css.rgb(68),
  textActive: _prometheusresearchReactUiStylesheet.css.rgb(255),
  textDisabled: '#dadada',

  background: _prometheusresearchReactUiStylesheet.css.color.transparent,
  backgroundHover: _prometheusresearchReactUiStylesheet.css.rgb(241),
  backgroundFocus: _prometheusresearchReactUiStylesheet.css.rgb(255),
  backgroundActive: _prometheusresearchReactUiStylesheet.css.rgb(180),
  backgroundDisabled: _prometheusresearchReactUiStylesheet.css.rgb(255),

  border: _prometheusresearchReactUiStylesheet.css.color.transparent,
  borderHover: _prometheusresearchReactUiStylesheet.css.color.transparent,
  borderFocus: _prometheusresearchReactUiStylesheet.css.color.transparent,
  borderActive: _prometheusresearchReactUiStylesheet.css.rgb(180),
  borderDisabled: _prometheusresearchReactUiStylesheet.css.color.transparent,

  shadowFocus: _prometheusresearchReactUiStylesheet.css.none,
  shadowActive: _prometheusresearchReactUiStylesheet.css.none
}, { displayName: 'ButtonBase' });

function Button(_ref) {
  var _ref$width = _ref.width;
  var width = _ref$width === undefined ? 1 : _ref$width;
  var _ref$height = _ref.height;
  var height = _ref$height === undefined ? 1 : _ref$height;
  var dim = _ref.dim;
  var emphasis = _ref.emphasis;
  var _ref$cellSize = _ref.cellSize;
  var cellSize = _ref$cellSize === undefined ? _theme.CELL_SIZE : _ref$cellSize;

  var props = _objectWithoutProperties(_ref, ['width', 'height', 'dim', 'emphasis', 'cellSize']);

  width = width * cellSize;
  height = height * cellSize;
  var style = {
    width: width, height: height,
    padding: 0,
    fontSize: '90%',
    fontWeight: emphasis ? 'bold' : 'normal',
    color: dim ? _prometheusresearchReactUiStylesheet.css.rgb(180) : undefined
  };
  return React.createElement(ButtonBase, _extends({}, props, { style: style }));
}

module.exports = exports['default'];
