/**
 * @copyright 2016-present, Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports['default'] = Label;

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _prometheusresearchReactUi = require('@prometheusresearch/react-ui');

var ReactUI = _interopRequireWildcard(_prometheusresearchReactUi);

var _prometheusresearchReactUiStylesheet = require('@prometheusresearch/react-ui/stylesheet');

var _theme = require('./theme');

var LabelBase = (0, _prometheusresearchReactUiStylesheet.style)(ReactUI.Block, {
  fontWidth: 300,
  color: _prometheusresearchReactUiStylesheet.css.rgb(70),
  background: _prometheusresearchReactUiStylesheet.css.color.transparent
}, { displayName: 'LabelBase' });

function Label(_ref) {
  var _ref$width = _ref.width;
  var width = _ref$width === undefined ? 1 : _ref$width;
  var _ref$height = _ref.height;
  var height = _ref$height === undefined ? 1 : _ref$height;
  var dim = _ref.dim;
  var emphasis = _ref.emphasis;
  var _ref$cellSize = _ref.cellSize;
  var cellSize = _ref$cellSize === undefined ? _theme.CELL_SIZE : _ref$cellSize;

  var props = _objectWithoutProperties(_ref, ['width', 'height', 'dim', 'emphasis', 'cellSize']);

  width = width * cellSize;
  height = height * cellSize;
  var style = {
    width: width, height: height,
    padding: 0,
    fontSize: '90%',
    fontWeight: emphasis ? 'bold' : 'normal',
    color: dim ? _prometheusresearchReactUiStylesheet.css.rgb(180) : undefined
  };
  return React.createElement(LabelBase, _extends({}, props, { inline: true, style: style }));
}

module.exports = exports['default'];
